package de.unisaar.jfap.ex4;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * Iterator wrapper around elements of array of type {@code T}.
 *
 * @author Bernd Kiefer, DFKI
 * @author Jörg Steffen, DFKI
 * @param <T> the type of elements returned by this iterator
 */
public class ArrayIterator<T> implements Iterator<T> {
  
  private T[] array;
  private int index;

  /**
   * Create a new iterator over the elements of the given array.
   *
   * @param array the array with the elements to iterator over
   */
  public ArrayIterator(T[] array) {
    this.array = array;
    this.index = 0;
  }

  @Override
  public boolean hasNext() {
    return this.index < this.array.length;
  }

  @Override
  public T next() {
    if (!hasNext()) {
      throw new NoSuchElementException();
    }
    return this.array[this.index++];
  }
}
