package de.unisaar.jfap.ex4;

import static org.assertj.core.api.Assertions.assertThat;
import static org.assertj.core.api.Assertions.assertThatExceptionOfType;

import java.util.Iterator;
import java.util.NoSuchElementException;
import org.junit.jupiter.api.Test;

class ArrayIteratorTest {

  @Test
  void testIteratorDefault() {
    String[] stringArray = new String[] {"one", "two", "three"};
    Iterator<String> it = new ArrayIterator<>(stringArray);
    for (String oneString : stringArray) {
      assertThat(it.hasNext()).isTrue();
      assertThat(it.next()).isEqualTo(oneString);
    }
    assertThat(it.hasNext()).isFalse();
    assertThatExceptionOfType(NoSuchElementException.class).isThrownBy(() -> it.next());
  }

  void testIteratorEmpty() {
    String[] stringArray = new String[0];
    Iterator<String> it = new ArrayIterator<>(stringArray);
    assertThat(it.hasNext()).isFalse();
    assertThatExceptionOfType(NoSuchElementException.class).isThrownBy(() -> it.next());
  }
}
