package de.unisaar.jfap.ex4;

import static org.assertj.core.api.Assertions.assertThat;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;
import org.junit.jupiter.api.Test;

class TextStatisticsTest {

  @Test
  void test() throws IOException {

    TextStatistics stats = new TextStatistics();
    List<String> lines = Files.readAllLines(Paths.get("src/test/data/sample.txt"));
    for (String oneLine : lines) {
      stats.countWords(oneLine);
      stats.countCharacters(oneLine);
    }
    // just probe some counts
    assertThat(stats.getWordCount("Shawshank")).isEqualTo(1);
    assertThat(stats.getWordCount("of")).isEqualTo(3);
    assertThat(stats.getWordCount("foobar")).isEqualTo(0);
    assertThat(stats.getCharacterCount('a')).isEqualTo(34);
    assertThat(stats.getCharacterCount('p')).isEqualTo(6);
    assertThat(stats.getCharacterCount('q')).isEqualTo(0);
  }
}
